/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_SOMEIP_STUB_ADAPTER_HPP_
#define V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_SOMEIP_STUB_ADAPTER_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioStub.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPStubAdapter.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPDeployment.hpp>
#include <v1/commonapi/telux/common/CommonDefinesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>
#include <CommonAPI/SomeIP/StubAdapterHelper.hpp>
#include <CommonAPI/SomeIP/StubAdapter.hpp>
#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Constants.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

template <typename _Stub = ::v1::commonapi::telux::cv2x::Cv2xRadioStub, typename... _Stubs>
class Cv2xRadioSomeIPStubAdapterInternal
    : public virtual Cv2xRadioStubAdapter,
      public ::v1::commonapi::telux::cv2x::Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...>
{
public:
    typedef CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...> Cv2xRadioSomeIPStubAdapterHelper;

    ~Cv2xRadioSomeIPStubAdapterInternal() {
        deactivateManagedInstances();
        Cv2xRadioSomeIPStubAdapterHelper::deinit();
    }

    void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status);

    void fireCurrentCv2xStatusExEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx &_statusEx);

    void fireCurrentL2AddrEvent(const uint32_t &_newL2Addr);

    void fireCurrentSpsOffsetEvent(const int32_t &_spsId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails &_details);

    void fireCurrentCapabilitiesEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities);

    void fireMacAddrCloneEvent(const bool &_detected);

    void deactivateManagedInstances() {}
    
    virtual void init(std::shared_ptr<CommonAPI::SomeIP::StubAdapter> instance) {
        return Cv2xRadioSomeIPStubAdapterHelper::init(instance);
    }

    virtual void deinit() {
        return Cv2xRadioSomeIPStubAdapterHelper::deinit();
    }

    virtual bool onInterfaceMessage(const CommonAPI::SomeIP::Message &_message) {
        return Cv2xRadioSomeIPStubAdapterHelper::onInterfaceMessage(_message);
    }
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        CommonAPI::Version
    > getCv2xRadioInterfaceVersionStubDispatcher;

    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType, uint16_t, std::vector< uint32_t >>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, uint32_t>,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint16_t>, CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<uint32_t> >>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>>
    > createRxSubscriptionStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus>,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::common::CommonDefines_::ServiceStatusDeployment_t>
    > getServiceStatusStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType, bool, std::vector< uint32_t >>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode>,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t, CommonAPI::EmptyDeployment, CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<uint32_t> >>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t>
    > enableRxMetaDataReportStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType, uint32_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo, uint16_t, bool, uint16_t>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, uint32_t, uint32_t, ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::common::CommonDefines::ErrorCode>,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::SpsFlowInfoDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint16_t>, CommonAPI::EmptyDeployment, CommonAPI::SomeIP::IntegerDeployment<uint16_t>>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>, CommonAPI::SomeIP::IntegerDeployment<uint32_t>, ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t>
    > createTxSpsFlowStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType, uint32_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo, uint16_t>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, uint32_t>,
        std::tuple< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::EventFlowInfoDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint16_t>>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>>
    > createTxEventFlowStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< uint32_t>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode>,
        std::tuple< CommonAPI::SomeIP::IntegerDeployment<uint32_t>>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t>
    > closeRxSubscriptionStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< uint32_t>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode>,
        std::tuple< CommonAPI::SomeIP::IntegerDeployment<uint32_t>>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t>
    > closeTxFlowStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< uint32_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode>,
        std::tuple< CommonAPI::SomeIP::IntegerDeployment<uint32_t>, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::SpsFlowInfoDeployment_t>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t>
    > changeSpsFlowInfoStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< uint32_t>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo>,
        std::tuple< CommonAPI::SomeIP::IntegerDeployment<uint32_t>>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::SpsFlowInfoDeployment_t>
    > requestSpsFlowInfoStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< uint32_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode>,
        std::tuple< CommonAPI::SomeIP::IntegerDeployment<uint32_t>, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::EventFlowInfoDeployment_t>,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t>
    > changeEventFlowInfoStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioStub,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities>,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xRadioCapabilitiesDeployment_t>
    > requestCapabilityStubDispatcher;
    
    Cv2xRadioSomeIPStubAdapterInternal(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub):
        CommonAPI::SomeIP::StubAdapter(_address, _connection),
                ::v1::commonapi::telux::cv2x::Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub),
        getCv2xRadioInterfaceVersionStubDispatcher(&Cv2xRadioStub::lockInterfaceVersionAttribute, &Cv2xRadioStub::getInterfaceVersion, false, true),
        createRxSubscriptionStubDispatcher(
            &Cv2xRadioStub::createRxSubscription,
            false,
            _stub->hasElement(0),
            std::make_tuple(static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint16_t>* >(nullptr), static_cast< CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<uint32_t> >* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr)))
        
        ,
        getServiceStatusStubDispatcher(
            &Cv2xRadioStub::getServiceStatus,
            false,
            _stub->hasElement(1),
            std::make_tuple(),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::common::CommonDefines_::ServiceStatusDeployment_t* >(nullptr)))
        
        ,
        enableRxMetaDataReportStubDispatcher(
            &Cv2xRadioStub::enableRxMetaDataReport,
            false,
            _stub->hasElement(2),
            std::make_tuple(static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t* >(nullptr), static_cast< CommonAPI::EmptyDeployment* >(nullptr), static_cast< CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<uint32_t> >* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr)))
        
        ,
        createTxSpsFlowStubDispatcher(
            &Cv2xRadioStub::createTxSpsFlow,
            false,
            _stub->hasElement(3),
            std::make_tuple(static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::SpsFlowInfoDeployment_t* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint16_t>* >(nullptr), static_cast< CommonAPI::EmptyDeployment* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint16_t>* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr), static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t* >(nullptr), static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t* >(nullptr)))
        
        ,
        createTxEventFlowStubDispatcher(
            &Cv2xRadioStub::createTxEventFlow,
            false,
            _stub->hasElement(4),
            std::make_tuple(static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::TrafficIpTypeDeployment_t* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::EventFlowInfoDeployment_t* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint16_t>* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr)))
        
        ,
        closeRxSubscriptionStubDispatcher(
            &Cv2xRadioStub::closeRxSubscription,
            false,
            _stub->hasElement(5),
            std::make_tuple(static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr)))
        
        ,
        closeTxFlowStubDispatcher(
            &Cv2xRadioStub::closeTxFlow,
            false,
            _stub->hasElement(6),
            std::make_tuple(static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr)))
        
        ,
        changeSpsFlowInfoStubDispatcher(
            &Cv2xRadioStub::changeSpsFlowInfo,
            false,
            _stub->hasElement(7),
            std::make_tuple(static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::SpsFlowInfoDeployment_t* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr)))
        
        ,
        requestSpsFlowInfoStubDispatcher(
            &Cv2xRadioStub::requestSpsFlowInfo,
            false,
            _stub->hasElement(8),
            std::make_tuple(static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::SpsFlowInfoDeployment_t* >(nullptr)))
        
        ,
        changeEventFlowInfoStubDispatcher(
            &Cv2xRadioStub::changeEventFlowInfo,
            false,
            _stub->hasElement(9),
            std::make_tuple(static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::EventFlowInfoDeployment_t* >(nullptr)),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr)))
        
        ,
        requestCapabilityStubDispatcher(
            &Cv2xRadioStub::requestCapability,
            false,
            _stub->hasElement(10),
            std::make_tuple(),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xRadioCapabilitiesDeployment_t* >(nullptr)))
        
    {
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7594) }, &createRxSubscriptionStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7595) }, &getServiceStatusStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7596) }, &enableRxMetaDataReportStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7597) }, &createTxSpsFlowStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7598) }, &createTxEventFlowStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7599) }, &closeRxSubscriptionStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x759a) }, &closeTxFlowStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x759b) }, &changeSpsFlowInfoStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x759c) }, &requestSpsFlowInfoStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x759d) }, &changeEventFlowInfoStubDispatcher );
        Cv2xRadioSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x759e) }, &requestCapabilityStubDispatcher );
        // Provided events/fields
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x8001));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x8006), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x8001));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x8001), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x8001));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x8002), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x8001));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x8003), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x8001));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x8004), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x8001));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x8005), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
    }

    // Register/Unregister event handlers for selective broadcasts
    void registerSelectiveEventHandlers();
    void unregisterSelectiveEventHandlers();

};

template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) {
    CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t> deployed_status(_status, static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x8006),
            false,
             deployed_status 
    );
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireCurrentCv2xStatusExEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx &_statusEx) {
    CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusExDeployment_t> deployed_statusEx(_statusEx, static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusExDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusExDeployment_t > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x8001),
            false,
             deployed_statusEx 
    );
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireCurrentL2AddrEvent(const uint32_t &_newL2Addr) {
    CommonAPI::Deployable< uint32_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>> deployed_newL2Addr(_newL2Addr, static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< uint32_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t> > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x8002),
            false,
             deployed_newL2Addr 
    );
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireCurrentSpsOffsetEvent(const int32_t &_spsId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails &_details) {
    CommonAPI::Deployable< int32_t, CommonAPI::SomeIP::IntegerDeployment<int32_t>> deployed_spsId(_spsId, static_cast< CommonAPI::SomeIP::IntegerDeployment<int32_t>* >(nullptr));
    CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::MacDetailsDeployment_t> deployed_details(_details, static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::MacDetailsDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< int32_t, CommonAPI::SomeIP::IntegerDeployment<int32_t> > 
    ,  CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::MacDetailsDeployment_t > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x8003),
            false,
             deployed_spsId 
            ,  deployed_details 
    );
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireCurrentCapabilitiesEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities) {
    CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xRadioCapabilitiesDeployment_t> deployed_capabilities(_capabilities, static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xRadioCapabilitiesDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xRadioCapabilitiesDeployment_t > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x8004),
            false,
             deployed_capabilities 
    );
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireMacAddrCloneEvent(const bool &_detected) {
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  bool
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x8005),
            false,
            _detected
    );
}


template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::registerSelectiveEventHandlers() {
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>::unregisterSelectiveEventHandlers() {
}

template <typename _Stub = ::v1::commonapi::telux::cv2x::Cv2xRadioStub, typename... _Stubs>
class Cv2xRadioSomeIPStubAdapter
    : public Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...> {
public:
    Cv2xRadioSomeIPStubAdapter(const CommonAPI::SomeIP::Address &_address,
                                            const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
                                            const std::shared_ptr<CommonAPI::StubBase> &_stub)
        : CommonAPI::SomeIP::StubAdapter(_address, _connection),
          Cv2xRadioSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub) {
    }
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_SOMEIP_STUB_ADAPTER_HPP_
